// Script Attaque Convoi GB1

using System;
using System.Collections.Generic;

using maddox.game;
using maddox.core;
using maddox.game.world;
using maddox.GP;

public class Mission : AMission
{
    bool flag_trigger00 = true;
    bool flag_J_leader =true;
    bool flag_tempo = false;
    double x2, y2;
    double delta_T = 40; //en s
    double time_Top;
    string ch1_texte = "";
    string boatChief = "9_Chief";
    AiActor acboat1;
    AiGroundActor boat1;

    public override void OnBattleStarted()
    {
        base.OnBattleStarted();
        time_Top = Time.current() + delta_T;
        ch1_texte = "";
        acboat1 = GamePlay.gpActorByName(boatChief);
        boat1 = (AiGroundActor)acboat1;
    }

    public override void OnTrigger(int missionNumber, string shortName, bool active)
    {
        if ("trigger00".Equals(shortName) && active && flag_trigger00)
        {
            if (flag_J_leader) { ch1_texte = "Suivez le cap : "; }
            else { ch1_texte = "Suivez le Leader, cap : "; }
            Point3d ptboat1 = boat1.Pos();
            x2 = ptboat1.x; y2 = ptboat1.y;
             ecritCap(x2, y2); 
            flag_trigger00 = false;
            flag_tempo = true;
            ch1_texte = "Suivez le cap : ";
        }
    }
    public override void OnTickGame()
    {
        // indication du cap ttes les delta_T secondes
        if (flag_J_leader && flag_tempo)
        {
            if (time_Top < Time.current())
            {
                ecritCap(x2, y2);
                time_Top = Time.current() + delta_T;
            }
        }
    }
    public void ecritCap(double x2, double y2)
    {
        Player Joueur = GamePlay.gpPlayer();
        Point3d pos = Joueur.Place().Pos();
        double alpha = Teta(pos.x, pos.y, x2, y2);
        int capJoueur = Cap(alpha);

        double dist = Math.Sqrt((x2 - pos.x) * (x2 - pos.x) + (y2 - pos.y) * (y2 - pos.y));
        if (dist < 8000) { flag_tempo = false; return; }
        GamePlay.gpHUDLogCenter(ch1_texte + capJoueur.ToString()); //+ " d:" + dist.ToString("0"));        
    }

    // ***** retourne un angle en rad, du vecteur AB avec l'axe des x  *****
    public double Teta(double xa, double ya, double xb, double yb)
    {
        double X, Y, angle;
        X = xb - xa;
        if (Math.Abs(X) < 0.001)
        {
            int s1 = Math.Sign(xa);
            int s2 = Math.Sign(xb);
            X = 0.001 * s1 * s2;
        }
        Y = yb - ya;
        angle = Math.Atan2(Y, X);
        if (X > 0.0 && Y > 0.0) { return angle; }
        if (X < 0.0 && Y > 0.0) { return angle; }
        if (X < 0.0 && Y < 0.0) { return Math.PI * 2.0 + angle; } //angle est <0 ds ce cas
        if (X > 0.0 && Y < 0.0) { return Math.PI * 2.0 + angle; } //angle est <0 ds ce cas
        else { return angle; }
    }
    // ***** calcule le cap en fonction de teta *****
    public static int Cap(double tetaRad)
    {
        int tetaDeg = (int)Math.Round((tetaRad * 180.0 / Math.PI), 0);
        int lecap = 0;
        if (90 >= tetaDeg) { lecap = 90 - tetaDeg; }
        if (tetaDeg >= 270) { lecap = 360 - tetaDeg + 90; }
        if (tetaDeg > 90 && tetaDeg <= 180) { lecap = 360 - tetaDeg + 90; }
        if (tetaDeg > 180 && tetaDeg < 270) { lecap = 360 - tetaDeg + 90; }
        return lecap;
    }
}
