// Script de Poursuite Bombers Axe 3
using System;
using System.IO;
using System.Collections.Generic;
using maddox.game;
using maddox.core;
using maddox.game.world;
using maddox.GP;


public class Mission : AMission
{
    bool flag_trigger00 = true;
    bool flag_trigger01 = true;
    bool flag_leader_J = true;
    bool flag_time_T2 = false;
    bool flag_time_T3 = false;
    double t0_T2, delta_T2;
    double t0_T3,delta_T3;
    int tempo_min_Blue = 0;
    int tempo_max_Blue = 10;
    int tempo_min_Red = 0;
    int tempo_max_Red = 10;
    double delta_T1 = 40; //en s
    double time_Top;
    double cibleX = 231214.91;
    double cibleY = 253554.54;
    int cap_Joueur = 0;
    string ch1_texte;
    
    AiAction action01, action02, action03;
    Random alea = new Random();

    public override void OnBattleStarted()
    {
        time_Top = Time.current() + delta_T1;
        ch1_texte = "";       
    }

    public override void OnTrigger(int missionNumber, string shortName, bool active)
    {
        if ("trigger00".Equals(shortName) && active && flag_trigger00)
        {
            if (flag_leader_J) { ch1_texte = "Suivez le cap : "; }
            else { ch1_texte = "Suivez le Leader, cap : "; }
            // GamePlay.gpHUDLogCenter(ch1_texte + cap_Joueur.Tostring());
            ecritCap(cibleX, cibleY);
            flag_trigger00 = false;
            ch1_texte = "Suivez le cap : ";
        }

        if ("trigger01".Equals(shortName) && active && flag_trigger01)
        {
            action01 = GamePlay.gpGetAction(ActorName.Full(missionNumber, "ASpawnBombersBlue"));
            action01.Do();         
            action02 = GamePlay.gpGetAction(ActorName.Full(missionNumber, "ASpawnFightersBlue"));
            action03 = GamePlay.gpGetAction(ActorName.Full(missionNumber, "ASpawnFightersRed"));

            delta_T2 = alea.Next(tempo_min_Blue, tempo_max_Blue); // temporisation
            t0_T2 = Time.current() + delta_T2;
            flag_time_T2 = true;
            flag_trigger01 = false;
            delta_T3 = alea.Next(tempo_min_Red, tempo_max_Red);
            t0_T3 = Time.current() + delta_T3;
            flag_time_T3 = true;
        }
    }

    public override void OnTickGame()
    {
        // on veut retarder l'apparition des chasseurs Blue de delta_T2 secondes
        if (flag_time_T2)
        {
            if (action02 == null) { flag_time_T2 = false; return; }
            //GamePlay.gpHUDLogCenter("Apparition Chasseur ds :" + (t0_T2 - Time.current()).ToString("0"));
            if (Time.current() > t0_T2)
            {
                action02.Do();
                flag_time_T2 = false;
            }
        }

        // on veut retarder l'apparition des chasseurs Red de delta_T3 secondes
        if (flag_time_T3)
        {
            if (action03 == null) { flag_time_T3 = false; return; }
            //GamePlay.gpHUDLogCenter("Apparition Chasseur ds :" + (t0_T3 - Time.current()).ToString("0"));
            if (Time.current() > t0_T3)
            {
                action03.Do();
                flag_time_T3 = false;
            }
        }

        // indication du cap ttes les delta_T1 secondes
        if (flag_leader_J && flag_trigger01)
        {
            // GamePlay.gpHUDLogCenter("");
            if (time_Top < Time.current() && ch1_texte != "")
            {
                ecritCap(cibleX, cibleY);
                time_Top = Time.current() + delta_T1;
            }
        }
    }

    public void ecritCap(double x2, double y2)
    {
        Player Joueur = GamePlay.gpPlayer();
        Point3d pos = Joueur.Place().Pos();
        double alpha = Teta(pos.x, pos.y, x2, y2);
        cap_Joueur = Cap(alpha);
        GamePlay.gpHUDLogCenter(ch1_texte + cap_Joueur.ToString());
    }

    // ***** retourne un angle en rad, du vecteur AB avec l'axe des x  *****
    public double Teta(double xa, double ya, double xb, double yb)
    {
        double X, Y, angle;
        X = xb - xa;
        if (Math.Abs(X) < 0.001)
        {
            int s1 = Math.Sign(xa);
            int s2 = Math.Sign(xb);
            X = 0.001 * s1 * s2;
        }
        Y = yb - ya;
        angle = Math.Atan2(Y, X);
        if (X > 0.0 && Y > 0.0) { return angle; }
        if (X < 0.0 && Y > 0.0) { return angle; }
        if (X < 0.0 && Y < 0.0) { return Math.PI * 2.0 + angle; } //angle est <0 ds ce cas
        if (X > 0.0 && Y < 0.0) { return Math.PI * 2.0 + angle; } //angle est <0 ds ce cas
        else { return angle; }
    }

    // ***** calcule le cap (degre) en fonction de teta (radian) *****
    public static int Cap(double tetaRad)
    {
        int tetaDeg = (int)Math.Round((tetaRad * 180.0 / Math.PI), 0);
        int lecap = 0;
        if (90 >= tetaDeg) { lecap = 90 - tetaDeg; }
        if (tetaDeg >= 270) { lecap = 360 - tetaDeg + 90; }
        if (tetaDeg > 90 && tetaDeg <= 180) { lecap = 360 - tetaDeg + 90; }
        if (tetaDeg > 180 && tetaDeg < 270) { lecap = 360 - tetaDeg + 90; }
        return lecap;
    }
    
}

